#include "basic_3d.h"
#include <iostream>

using namespace std;
using namespace scene3d;
using namespace abmt;


void grid_xy::init(){
    for(int x = -param_steps_x/2; x <= param_steps_x/2; ++x){
        auto l = std::make_shared<abmt::line3d>();
        l->color = {85,85,85,255};
        l->p1 = {x*param_step_size, -param_steps_y/2*param_step_size, param_z};
        l->p2 = {x*param_step_size,  param_steps_y/2*param_step_size, param_z};
        out_sc.lines.push_back(l);      
    }
    
    for(int y = -param_steps_y/2; y <= param_steps_y/2; ++y){
        auto l = std::make_shared<abmt::line3d>();
        l->color = {85,85,85,255};
        l->p1 = {-param_steps_x/2*param_step_size, y*param_step_size, param_z};
        l->p2 = { param_steps_x/2*param_step_size, y*param_step_size, param_z};
        out_sc.lines.push_back(l);      
    }

}

void grid_xz::init(){
    for(int x = -param_steps_x/2; x <= param_steps_x/2; ++x){
        auto l = std::make_shared<abmt::line3d>();
        l->color = {85,85,85,255};
        l->p1 = {x*param_step_size, param_y, -param_steps_z/2*param_step_size};
        l->p2 = {x*param_step_size, param_y, param_steps_z/2*param_step_size};
        out_sc.lines.push_back(l);      
    }
    
    for(int z = -param_steps_z/2; z <= param_steps_z/2; ++z){
        auto l = std::make_shared<abmt::line3d>();
        l->color = {85,85,85,255};
        l->p1 = {-param_steps_x/2*param_step_size, param_y, z*param_step_size};
        l->p2 = { param_steps_x/2*param_step_size, param_y, z*param_step_size};
        out_sc.lines.push_back(l);      
    }

}

void grid_yz::init(){
    for(int y = -param_steps_y/2; y <= param_steps_y/2; ++y){
        auto l = std::make_shared<abmt::line3d>();
        l->color = {85,85,85,255};
        l->p1 = {param_x, y*param_step_size, -param_steps_z/2*param_step_size};
        l->p2 = {param_x, y*param_step_size,  param_steps_z/2*param_step_size};
        out_sc.lines.push_back(l);      
    }
    for(int z = -param_steps_z/2; z <= param_steps_z/2; ++z){
        auto l = std::make_shared<abmt::line3d>();
        l->color = {85,85,85,255};
        l->p1 = {param_x, -param_steps_y/2*param_step_size, z*param_step_size};
        l->p2 = {param_x,  param_steps_y/2*param_step_size, z*param_step_size};
        out_sc.lines.push_back(l);      
    }
}

void axis::init(){
  auto lr = std::make_shared<line3d>();
  lr->color = {255,0,0,255};
  lr->p2.x = param_len;
  out_sc.lines.push_back(lr);
  
  auto lg = std::make_shared<line3d>();
  lg->color = {0,255,0,255};
  lg->p2.y = param_len;
  out_sc.lines.push_back(lg);
 
  auto lb = std::make_shared<line3d>();
  lb->color = {0,0,255,255};
  lb->p2.z = param_len;
  out_sc.lines.push_back(lb);
}