#ifndef MATH3D_EXAMPLE_BASIC_3D_H
#define MATH3D_EXAMPLE_BASIC_3D_H MATH3D_EXAMPLE_BASIC_3D_H

#include <abmt/3d.h>
#include <iostream>
namespace scene3d{

//@node: auto
struct move{
    abmt::pose out_pose;
    float in_x = 0;
    float in_y = 0;
    float in_z = 0;
    
    void tick(){
        out_pose.x = in_x;
        out_pose.y = in_y;
        out_pose.z = in_z;
    }
};

//@node: auto
struct rotate{
    abmt::pose out_pose;
    
    float in_ang;
    float in_x = 1;
    float in_y = 0;
    float in_z = 0;
    
    void tick(){
        out_pose = abmt::rot_vec({in_x, in_y, in_z}, in_ang);
    }
};

//@node: auto
struct cube{
    abmt::scene out_sc;
    std::shared_ptr<abmt::cuboid> cube;
    
    float in_size_x = 1;
    float in_size_y = 1;
    float in_size_z = 1;
    
    void init(){
       cube.reset(new abmt::cuboid);
       out_sc.cubes.push_back(cube);
    }
    
    void tick(){
        cube->size.x = in_size_x;
        cube->size.y = in_size_y;
        cube->size.z = in_size_z;
    }
};

//@node: auto
struct grid_xy{
    abmt::scene out_sc;
    double param_step_size = 1.0;
    int param_steps_x = 10;
    int param_steps_y = 10;
    float param_z = -0.001;
    void init();
};

//@node: auto
struct grid_xz{
    abmt::scene out_sc;
    double param_step_size = 1.0;
    int param_steps_x = 10;
    int param_steps_z = 10;
    float param_y = -0.001;
    void init();
};
//@node: auto
struct grid_yz{
    abmt::scene out_sc;
    double param_step_size = 1.0;
    int param_steps_y = 10;
    int param_steps_z = 10;
    float param_x = -0.001;
    void init();
};

//@node: auto
struct axis{
    abmt::scene out_sc;
    double param_len = 1.0;
    void init();
};


} // namespace scene3d

#endif // MATH3D_EXAMPLE_BASIC_3D_H
