#include "star_scene.h"

using namespace std;
using namespace scene3d;

void star_scene::init(){
    for(int i=0; i < param_n_stars; ++i){
      auto p = std::make_shared<abmt::cuboid>();
      p->p.x = (rand() % 50*1000) / 1000.0 - 25; // 10m in mm
      p->p.y = (rand() % 15*1000) / 1000.0 - 1; // 10m in mm
      p->p.z = (rand() % 75*1000) / 1000.0 - 75; // 10m in mm
      p->color.r = (rand() % 255);
      p->color.g = (rand() % 255);
      p->color.b = (rand() % 255);
      p->color.a = (rand() % 100) + 155;
      p->size.x = 0.5 + (rand() % 4 * 1000) / 1000.0;
      p->size.y = 0.5 + (rand() % 4 * 1000) / 1000.0;
      p->size.z = 0.5 + (rand() % 4 * 1000) / 1000.0;
      
      scene_internal.cubes.push_back(p);
    }
    
    for(int i=0; i < param_n_stars*10; ++i){
      auto p = std::make_shared<abmt::point3d>();
      p->pos.x = (rand() % 50*1000) / 1000.0 - 25 + 50; // 10m in mm
      p->pos.y = (rand() % 15*1000) / 1000.0 - 1; // 10m in mm
      p->pos.z = (rand() % 75*1000) / 1000.0 - 75; // 10m in mm
      p->color.r = (rand() % 255);
      p->color.g = (rand() % 255);
      p->color.b = (rand() % 255);
      p->color.a = (rand() % 100) + 155;;
      p->size    =  (rand() % 4 * 1000) / 1000.0 / 4;
      
      scene_internal.points.push_back(p);
    }
    
    sp = std::make_shared<abmt::spline>();
    sp->path = "test_logo.png";
    scene_internal.splines.push_back(sp);
    
    sp2 = std::make_shared<abmt::spline>();
    sp2->p.z = -0.1;
    scene_internal.splines.push_back(sp2);
    
    out_scene = scene_internal;
}

void star_scene::tick(){
    auto c = out_scene.cubes[0];
    
    sp->p.z = c->p.x *2;
    sp2->img = in_image;
    
    for(auto c:scene_internal.cubes){
            c->p.z += 0.2;
            if(c->p.z > 0){
                    c->p.z = -75;
            }
            
    }
    for(auto c:scene_internal.points){
            c->pos.z += 0.3;
            if(c->pos.z > 0){
                    c->pos.z = -75;
            }
            
    }
    out_scene = scene_internal;
}
