/**
 * Author: Hendrik van Arragon, 2021
 * SPDX-License-Identifier: MIT
 */

#ifndef UTIL_INC_MUTEX_H_
#define UTIL_INC_MUTEX_H_

#include <pthread.h>

namespace abmt{

class scope_lock;

class mutex{
public:
	pthread_mutex_t mtx;
	mutex();
	void lock();
	void unlock();
	scope_lock get_scope_lock();
};

class scope_lock{
public:
	mutex& m;
	scope_lock(mutex& m);
	~scope_lock();
};

} // namespace abmt

#endif /* UTIL_INC_MUTEX_H_ */
