/**
 * Author: Hendrik van Arragon, 2021
 * SPDX-License-Identifier: MIT
 */

#ifndef SHARED_ABMT_RT_RASTER_H_
#define SHARED_ABMT_RT_RASTER_H_

#include <cstdint>
#include <functional>
#include <vector>

namespace abmt{
namespace rt{

class raster{
public:
	const char* name;
	virtual void init_tick() = 0;
	virtual void tick() = 0;
	virtual void final() = 0;
	virtual ~raster(){};
};

class raster_sync: public raster{
public:
	uint64_t interval_ns;
};


class raster_async: public raster{
public:
	virtual void init() = 0;
	virtual bool poll() = 0;
};


} // namespace runtime
} // namespace abmt


#endif /* INC_RASTER_H_ */
