/**
 * Author: Hendrik van Arragon, 2021
 * SPDX-License-Identifier: MIT
 */

#include <abmt/mutex.h>

using namespace abmt;

mutex::mutex(){
	pthread_mutex_init(&mtx,NULL);
}
void mutex::lock(){
	 pthread_mutex_lock (&mtx);
}
void mutex::unlock(){
	 pthread_mutex_unlock (&mtx);
	}

scope_lock mutex::get_scope_lock(){
	return scope_lock(*this);
}

scope_lock::scope_lock(mutex& m):m(m){
	m.lock();
}
scope_lock::~scope_lock(){
	m.unlock();
}






